"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generator = exports.palette = void 0;
const grid_1 = require("../utils/grid");
const geometry_1 = require("../utils/geometry");
const SIZE = 10;
// Taken from: https://dribbble.com/shots/6679208--Charm-Pattern
exports.palette = [
    "#3ABAAD",
    "#D52B5F",
    "#336091",
    "#FBF3D7",
    "#F69257",
    "#4D235B"
];
// Inspired by: https://dribbble.com/shots/6679208--Charm-Pattern
const generator = async (ctx, random) => {
    const backgroundColor = "#FBF3D7";
    ctx.fillStyle = backgroundColor;
    ctx.fillRect(0, 0, ctx.canvas.width, ctx.canvas.height);
    const grid = new grid_1.HexGrid(ctx, SIZE, SIZE, Math.max(ctx.canvas.width, ctx.canvas.height) / SIZE);
    for (const cell of grid.cells) {
        cell.fill(random.color());
        const points = random.sequence(3, cell.shape.points);
        const arch = new geometry_1.Arch(points[0], points[2], cell.shape.center);
        const triangle = new geometry_1.Polygon(...points);
        cell.draw(ctx => {
            ctx.fillStyle = random.color();
            ctx.beginPath();
            triangle.draw(ctx);
            arch.draw(ctx);
            ctx.fill();
        });
    }
};
exports.generator = generator;
//# sourceMappingURL=charm.js.map