"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generator = exports.palette = void 0;
const grid_1 = require("../utils/grid");
const geometry_1 = require("../utils/geometry");
const ROWS = 4;
const COLUMNS = 4;
// Several sources, search for "Minimalistic Geometric Scandinavian"
exports.palette = [
    "#37313F",
    "#A09EB1",
    "#EAE0E1",
    "#E0B4C1",
    "#C13E68",
    "#404B78",
    "#0EB285"
];
// Several sources, search for "Minimalistic Geometric Scandinavian"
const generator = async (ctx, random) => {
    const grid = new grid_1.SquareGrid(ctx, COLUMNS, ROWS);
    for (const cell of grid.cells) {
        cell.draw(ctx => {
            // Fill the background
            cell.fill(random.color());
            // Gather three random points
            const points = random.sequence(3, cell.shape.points);
            // Draw either a circle or a triangle for the points
            ctx.beginPath();
            let shape;
            if (random.bool())
                shape = new geometry_1.Circle(points[0], Math.max(cell.shape.size.width, cell.shape.size.height));
            else
                shape = new geometry_1.Polygon(...points);
            shape.draw(ctx);
            ctx.fillStyle = random.color();
            ctx.fill();
        });
    }
};
exports.generator = generator;
//# sourceMappingURL=scandinavian.js.map